unit uAnagrammes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    ListBox1: TListBox;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function Permute(const aValue : string; const aLst : TStrings) : Boolean;
var
  sTmp : string;
  iCount, i : Integer;
  LstTmp : TStringList;
  FirstChar : Char;
begin
  Result := False;
  LstTmp := TStringList.Create;

  try

  iCount := 0;

  if Length(aValue) > 1 then
  begin
    sTmp := AValue;

    while iCount < Length(aValue) do
    begin
      lstTmp.Clear;

      if Permute(Copy(sTmp, 2, Length(sTmp)-1), LstTmp) then
      begin
        FirstChar := sTmp[1];

        for i := 0 to lstTmp.Count-1 do
          aLst.Add(FirstChar + lstTmp[i]);

        sTmp := Copy(sTmp, 2, Length(sTmp)-1) + FirstChar;
      end;

      Inc(iCount);
    end;
  end
  else
    aLst.Add(AValue);

  Result := True;

  finally

  LstTmp.Free;
  
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ListBox1.Clear;
  Permute(Edit1.Text, ListBox1.Items);
  ListBox1.Items.SaveToFile('Sortie\'+Edit1.Text+'.txt');
end;

end.
